;Control motors and count its rotation frequency on f@#$in' MCS51.
;This version works in BCD.
;
;Greetings to SkyDragon (2:5063/52.6)
;With best regards from Slayer ( N0 Fid0 at all 8-E~~~~~~~~ )

        f_rev bit 01h
        f_work bit 02h
        p4 data 0e8h
        p5 data 0f8h
        ien0 data 0a8h
        ien1 data 0b8h
        no_int0 equ 00h
        en_int0 equ 87h

        org 0000h
        ljmp start
        org 0003h
        ljmp keyboard
        org 000Bh
        ljmp TIM0
        org 0013h
        inc 40h          ;increase int1 counter
        reti

Start:
        clr f_rev
        clr f_work
        mov sp,#60h
        mov TMOD,#1
        setb TR0
        setb TF0
        setb IT1
        mov ien0, #en_int0
        mov 46h, #00h
        mov 47h, #00h
        mov 48h, #00h
        mov 49h, #00h
        mov 40h, #0   ;int1 counter
        mov 41h, #0   ;refresh counter indicate every 1/4sec

        mov dptr,#font
Ind:
        mov r4, #0feh
        mov r0,#46h
Nxt:    mov a, @r0
        mov p4, #0ffh
        movc a, @a+dptr
        mov p5, a
        mov a, r4
        mov p4, a
        rl a
        mov r4, a
        inc r0
        lcall del
        cjne r0, #4ah, nxt
        ljmp ind
del:    mov r1,#10
st_2:   mov r2,#10
st_1:   nop
        nop
        nop
        djnz r2,st_1
        djnz r1,st_2
        ret

; keyboard interrupt handler
Keyboard:
       push acc
       push p4
       push psw
       setb  psw.3
       mov r4,#00h
       mov r7,#04h
       mov r6,#0feh
loop:  mov a,r6
       mov p4,a
       rl a
       mov r6,a
       mov a,p4
       mov r5,#04h
       swap a
rotate:rrc a
       jnc dbnc
       inc r4
       djnz r5,rotate
       djnz r7,loop
       ljmp quit
dbnc:  mov r2,#0ah
m1:    mov r3,#55h
m2:    djnz r3,m2
       djnz r2,m1
       mov a,#0f0h
wait:  mov p4,#0f0h
       cjne a,p4,wait
       mov r2,#0ah
m3:    mov r3,#55h
m4:    djnz r3,m4
       djnz r2,m3
       mov a,#09h
       subb a,r4
       jc func
       mov 49h, 48h
       mov 48h, 47h
       mov 47h, 46h
       mov 46h,r4
       ljmp quit
func:  cjne r4, #0ah, g1        ; start
       lcall Engage
       sjmp quit
g1:    cjne r4, #0bh, g2        ; stop
       lcall stop
       sjmp quit
g2:    lcall reverse
quit:  clr psw.3
       pop psw
       pop p4
       pop acc
       reti

Engage: setb f_work
        jb f_rev, rev
        clr p3.4                ; Engage
        setb p3.5
        sjmp ex
rev:    setb p3.4
        clr p3.5
ex:
        ret

Stop:   setb p3.4
        setb p3.5
        clr f_work
        mov 46h, #00h
        mov 47h, #00h
        mov 48h, #00h
        mov 49h, #00h
        ret

Reverse:cpl f_rev
        jnb f_work, ex_rev
        lcall stop
        lcall engage
ex_rev:
        ret

TIM0:
       jnb  f_work,ext1
       push psw
       push acc
       inc  41h         ;refresh counter
       mov a,#24         ;refresh every 1/2sec
       cjne a,41h,ext
       mov 41h,#0       ;zero refresh counter
       mov a,40h        ;get int1 counter
       mov b,#3Ch       ;get frequency za odnu minutu
       mul ab           ;--------------------

       mov  R0,#46h
       mov  R2,b
       mov  R3,a

; Convert binary word at AB to BCD at 46h-49h and indicate it
; Konvertirovat' dvoichnoe slovo iz AB v BCD v yacheikah 46h-49h
;    i indicirovat' ih

       mov  a,R2
k1:
       mov  b,#10
       div  ab
       mov  35h,a
       mov  a,R3
       anl  a,#0F0h
       swap a
       mov  R4,a
       mov  a,b
       swap a
       add  a,R4
       mov  b,#10
       div  ab
       mov  36h,a
       mov  a,R3
       anl  a,#0Fh
       mov  R4,a
       mov  a,b
       swap a
       orl  a,R4
       mov  b,#10
       div  ab
       mov  37h,a
       mov  @R0,b
       inc  R0
       mov  a,36h
       swap a
       orl  a,37h
       mov  R3,a
       mov  a,35h
       mov  R2,a
       jnz  k1
       mov  a,R3
       mov  b,#10
       div  ab
       mov  @R0,b
       inc  R0
       mov  R4,a
       mov  b,#10
       div  ab
       jnz  k2
       mov  a,R4
       mov  @R0,a
       sjmp K3
k2:
       mov @R0,a
       inc R0
       mov @R0,a
k3:

ext:
       mov  40h,#0
       pop  acc
       pop  psw
ext1:
       mov  TH0,#0A2h
       mov  TL0,#040h
       reti

; ----Tablica kodoff znakogeneratora--------------------
;          0    1    2   3    4   5   6   7    8   9   a  b    c   d     e   f
FONT: DB 0C0H,0F9H,0A4H,0B0H,99H,92H,82H,0F8H,80H,90H,88H,83H,0C6H,0A1H,86H,8Eh

        end ; End proggy