F_INDI  EQU 00H
F_BEBE  equ 01h

F_FLASH EQU 02H


LEN_0   EQU 08H
LEN_1   EQU 08H
LEN_2   EQU 06H

KEY_RI  EQU 12H
KEY_UP  EQU 11H
KEY_RS  EQU 10H

DO1     EQU 00H
DO1_    EQU 01H
RE1     EQU 02H
RE1_    EQU 03H
MI1     EQU 04H
FA1     EQU 05H
FA1_    EQU 06H
SOL1    EQU 07H
SOL1_   EQU 08H
LA1     EQU 09H
LA1_    EQU 0AH
SI1     EQU 0BH

DO2     EQU 0CH
DO2_    EQU 0DH
RE2     EQU 0EH
RE2_    EQU 0FH
MI2     EQU 10H
FA2     EQU 11H
FA2_    EQU 12H
SOL2    EQU 13H
SOL2_   EQU 14H
LA2     EQU 15H
LA2_    EQU 16H
SI2     EQU 17H

DO3     EQU 18H
DO3_    EQU 19H
RE3     EQU 1AH
RE3_    EQU 1BH
MI3     EQU 1CH
FA3     EQU 1DH
FA3_    EQU 1EH
SOL3    EQU 1FH
SOL3_   EQU 20H
LA3     EQU 21H
LA3_    EQU 22H
SI3     EQU 23H
DE      EQU 24H
CONSTAN equ 49995

        ORG 0000H
        SJMP INI
        ORG 000BH
        AJMP INTERP

        ORG 0020H
INI:    MOV SP,#40H
        MOV R0,#3FH
        MOV R1,#20H
        MOV A,#00
LOOP:   MOV @R1,#00H
        INC R1
        DJNZ R0,LOOP
        MOV 34H,#80H
;       MOV 20H,#00
;       MOV 22H,#00

;               MOV DPTR,#GO
;               LCALL MUSIC

        MOV TMOD,#91H
        MOV IP,#02H
        MOV IE,#82H
        SETB F_INDI

        MOV TH0,#0EEH
        MOV TL0,#0EEH
        SETB TCON.4



CL0:    LCALL KEYB_SC
        JNB F_INDI,CL1
        LCALL TIMER
        LCALL VIEV
CL1:    JNB F_BEBE,CL5
                MOV A,29H
                CJNE A,#00,CL2
                LCALL MUSIC_0

                MOV A,31H
                ADDC A,#LEN_0
                MOV 31H,A
                SJMP CL0

CL2:            CJNE A,#01,CL3
                LCALL MUSIC_1

                MOV A,31H
                ADDC A,#LEN_1
                MOV 31H,A
                SJMP CL0

CL3:            CJNE A,#02,CL5
                LCALL MUSIC_2

                MOV A,31H
                ADDC A,#LEN_2
                MOV 31H,A
                SJMP CL0


CL5:    SJMP CL0





INTERP: PUSH 0E0H
        PUSH 0F0H

        CLR TCON.4
        MOV TH0,#HIGH(NOT(CONSTAN))
        MOV TL0,#LOW (NOT(CONSTAN))


        SETB TCON.4
        MOV A,30H
        ADD A,#01
        DA A
        MOV 30H,A

        MOV B,#6H
        DIV AB

        CLR F_FLASH
        CJNE A,#01H,INT_00
                SETB F_INDI
INT_00: CJNE A,#02H,INT_0
                SETB F_INDI
INT_0:  CJNE A,#03H,INT_1
                SETB F_FLASH
                SETB F_INDI


INT_1:  MOV A,30H

        CJNE A,#20H,INT_RET
                MOV 30H,#00
                MOV A,31H
                ADD A,#01
                DA A
                MOV 31H,A

        CJNE A,#60H,INT_RET
                MOV 31H,#00
                MOV A,32H
                ADD A,#01
                DA A
                MOV 32H,A

        CJNE A,#60H,INT_RET
                MOV 32H,#00
                MOV A,33H
                ADD A,#01
                DA A
                MOV 33H,A

        CJNE A,#24H,INT_RET
                MOV 33H,#00
                MOV A,34H
                ADD A,#01
                DA A
                MOV 34H,A

        CJNE A,#87H,INT_RET
                MOV 34H,#80H

INT_RET:        POP 0F0H
                POP 0E0H
                RETI





KEYB_SC: SETB P3.0
        SETB P3.1
        SETB P3.2
        MOV A,P3
        CPL A
        ANL A,#07H
        MOV 22H,A
                JNB KEY_RI,KS1                  ; " -> "
                        INC 35H
                        MOV A,35H
                        CJNE A,#05H,KS0
                                MOV 35H,#00
KS0:                    SJMP KE_RET
KS1:            JNB KEY_UP,KS2                  ; " + "
                        MOV A,35H
                        CJNE A,#01,KM1
                                MOV A,33H
                                ADD A,#01
                                DA A
                                MOV 33H,A
                                CJNE A,#24H,KT1
                                        MOV 33H,#00
KT1:                            SJMP KE_RET
KM1:                    CJNE A,#02,KM2
                                MOV A,32H
                                ADD A,#01
                                DA A
                                MOV 32H,A
                                CJNE A,#60H,KT2
                                        MOV 32H,#00
KT2:                            SJMP KE_RET
KM2:                    CJNE A,#03,KM3
                                MOV 31H,#00
                                SJMP KE_RET
KM3:                    CJNE A,#04,KM4
                                MOV A,34H
                                ADD A,#01

                                MOV 34H,A
                                CJNE A,#87H,KT4
                                        MOV 34H,#80H
KT4:                            SJMP KE_RET
KM4:                    SJMP KE_RET

KS2:            JNB KEY_RS,KE_END
                        MOV A,35H
                        CJNE A,#00,KS3
                                SJMP KE_END

KS3:                            MOV 31H,#00
                                MOV 32H,#00
KE_RET: CLR F_FLASH
        MOV P1,00
        LCALL VIEV
        LCALL DELAY

KE_END: RET

DELAY:  PUSH 00
        PUSH 01
        PUSH 02
        MOV R0,#04
DL2:    MOV R1,#0FFH
DL1:    MOV R2,#0FFH
DL0:    DJNZ R2,DL0
        DJNZ R1,DL1
        DJNZ R0,DL2
        POP 02
        POP 01
        POP 00
        RET





VIEV:   MOV A,35H

        CJNE A,#00,VI1
        MOV 3EH,33H
        MOV 3FH,32H
        CLR 20H
        CLR 21H
        CLR 22H
        CLR 23H
        SJMP VI5

VI1:    CJNE A,#01,VI2
        MOV 3EH,33H
        MOV 3FH,32H
        SETB 20H
        SETB 21H
        CLR 22H
        CLR 23H
        SJMP VI5

VI2:    CJNE A,#02,VI3
        MOV 3EH,33H
        MOV 3FH,32H
        CLR 20H
        CLR 21H
        SETB 22H
        SETB 23H
        SJMP VI5

VI3:    CJNE A,#03,VI4
        MOV 3EH,#0AAH
        MOV 3FH,31H
        MOV 3AH,#0FFH
        MOV 3BH,#0FFH
        MOV 3CH,#00
        MOV 3DH,#00
        SJMP VI5

VI4:    CJNE A,#04,VI6
        MOV 3EH,#0AAH
        MOV 3FH,34H
        MOV 3AH,#0FFH
        MOV 3BH,#0FFH
        MOV 3CH,#00
        MOV 3DH,#00
        SJMP VI5

VI5:    LCALL DISPLAY
VI6:    RET

DISPLAY: MOV A,3FH
        JBC 0E7H,COPY_WE
        MOV DPTR,#UDG
        PUSH 0E0H
        ANL A,#0FH
        MOVC A,@A+DPTR
        MOV 39H,A
        POP 0E0H
        ANL A,#0F0H
        SWAP A
        MOVC A,@A+DPTR
        MOV 38H,A

        MOV A,3EH
        PUSH 0E0H
        ANL A,#0FH
        MOVC A,@A+DPTR
        MOV 37H,A
        POP 0E0H
        ANL A,#0F0H
        SWAP A
        MOVC A,@A+DPTR
        MOV 36H,A

        SJMP DISP1


COPY_WE: MOV DPTR,#WEEK
        MOV B,#02
        MUL AB
        PUSH 0E0H
        MOVC A,@A+DPTR
        MOV 38H,A
        INC DPTR
        POP 0E0H
        MOVC A,@A+DPTR
        MOV 39H,A
        MOV 36H,#0FFH
        MOV 37H,#0FFH

DISP1:  JNB F_FLASH,DISP2
                JNB 20H,DI_1
                        MOV 36H,#0FFH
DI_1:           JNB 21H,DI_2
                        MOV 37H,#0FFH
DI_2:           JNB 22H,DI_3
                        MOV 38H,#0FFH
DI_3:           JNB 23H,DISP2
                        MOV 39H,#0FFH

DISP2:  MOV P1,39H
        SETB P3.4
        CLR P3.4

        MOV P1,38H
        SETB P3.5
        CLR P3.5

        MOV P1,37H
        SETB P3.6
        CLR P3.6

        MOV P1,36H
        SETB P3.7
        CLR P3.7


        CLR F_INDI
        RET





TIMER:
        MOV A,34H
        CJNE A,#86H,TB0
                SJMP TI_RET
TB0:    CJNE A,#85H,TB1
                MOV DPTR,#RASP_3
                LCALL COMP
                JNB PSW.5,TE_1
                        MOV 29H,#00
                        SETB F_BEBE
                        CLR PSW.5
                        SJMP TI_RET

TE_1:           MOV DPTR,#RASP_4
                LCALL COMP
                JNB PSW.5,TE_2
                        MOV 29H,#01
                        SETB F_BEBE
                        CLR PSW.5
                        SJMP TI_RET

TE_2:           MOV DPTR,#RASP_5
                LCALL COMP
                JNB PSW.5,TE_3
                        MOV 29H,#02
                        SETB F_BEBE
                        CLR PSW.5
                        SJMP TI_RET

TE_3:           SJMP TI_RET

TB1:    MOV DPTR,#RASP_0
        LCALL COMP
        JNB PSW.5,TE_4
                MOV 29H,#00
                SETB F_BEBE
                CLR PSW.5
                SJMP TI_RET

TE_4:   MOV DPTR,#RASP_1
        LCALL COMP
        JNB PSW.5,TE_5
                MOV 29H,#01
                SETB F_BEBE
                CLR PSW.5
                SJMP TI_RET

TE_5:   MOV DPTR,#RASP_2
        LCALL COMP
        JNB PSW.5,TI_RET
                MOV 29H,#02
                SETB F_BEBE
                CLR PSW.5
                SJMP TI_RET
TI_RET: RET

COMP:   MOV R0,#33H
        MOV R2,#06H
        MOV A,#00

M2:     CLR C
        PUSH 0E0H

        MOVC A,@A+DPTR
        SUBB A,@R0
        DEC R0
        JNZ M1
                CLR C
                POP 0E0H
                INC A
                PUSH 0E0H
                MOVC A,@A+DPTR
                SUBB A,@R0
                JNZ M3
                        MOV A,31H
                        CJNE A,#00,M3
                                SETB PSW.5
M1:     POP 0E0H
        INC A
        PUSH 0E0H
M3:     POP 0E0H
        INC A
        MOV R0,#33H

        DJNZ R2,M2
        RET




MUSIC_0: MOV DPTR,#MELO_0
        LCALL MUSIC
        RET

MUSIC_1: MOV DPTR,#MELO_1
        LCALL MUSIC
        RET

MUSIC_2: MOV DPTR,#MELO_2
        LCALL MUSIC
        RET


MUSIC:  CLR IE.7
        CLR TCON.4
        PUSH 89H
        MOV TMOD,#11H
MU_1:   CLR A
        MOVC A,@A+DPTR
        JZ EXIT
        MOV B,A
        MOV A,#16
        DIV AB
        RL A
        MOV R7,A
        INC DPTR
        CLR A
        MOVC A,@A+DPTR
        RL A
        MOV R6,A

SOUND:  CLR TCON.4
        MOV TL0,#LOW(NOT(65500)+1)
        MOV TH0,#HIGH(NOT(65500)+1)
        SETB TCON.4
S1:     JBC TCON.5,S2
        CPL P3.3
        CLR TCON.6
                PUSH 82H
                PUSH 83H
                MOV DPTR,#TAB
                MOV A,R6
                MOVC A,@A+DPTR
                CPL A
                MOV TH1,A
                MOV A,R6
                INC DPTR
                MOVC A,@A+DPTR
                CPL A
                MOV TL1,A
                POP 83H
                POP 82H
        SETB TCON.6
S0:     JBC TCON.7,S1
        SJMP S0

S2:     DJNZ R7,SOUND
        INC DPTR
        SJMP MU_1

EXIT:   POP 89H
        SETB TCON.4
        SETB IE.7
        CLR 01
        RET

TAB:    DW 1880,1772,1668,1576,1484,1400,1302,1244,1172,1120,1057,996
        DW 940,886,834,788,742,700,651,622,586,560,528,448
        DW 470,443,417,384,371,350,325,311,293,280,264,224,65535



RASP_0: DB 07H,13H,08H,43H,10H,18H,11H,58H,13H,28H,14H,58H

RASP_1: DB 07H,15H,08H,45H,10H,20H,12H,00H,13H,30H,15H,00H

RASP_2: DB 08H,35H,10H,05H,11H,40H,13H,20H,14H,50H,16H,20H

RASP_3: DB 07H,18H,08H,43H,10H,08H,11H,33H,12H,58H,14H,23H

RASP_4: DB 07H,20H,08H,45H,10H,10H,11H,35H,13H,00H,14H,25H

RASP_5: DB 08H,35H,10H,00H,11H,25H,12H,50H,14H,15H,15H,40H

UDG:    DB 0C0H,0F9H,0A4H,0B0H,99H,92H,82H,0F8H,80H,90H,0FFH

WEEK:   DB 0C8H,89H
        DB 80H,89H
        DB 0C6H,8CH
        DB 99H,0CEH
        DB 0C8H,41H
        DB 0C6H,82H
        DB 80H,0C6H

GO:     DB 16,FA3,16,LA3,16,SI3,0



;DIRhy12a

;MELO_0:        DB 8,SOL1,8,LA1,16,DO2,16,DE,16,DO2,16,DO2,16,DO2
        DB 8,LA1,8,SOL1,8,MI1,8,SOL1,2,DO2,4,DO2,8,DO2,8,RE2

        DB 16,MI2,16,DE,16,MI2,16,DE,16,MI2,16,DE,16,MI2,16,DE,8,SOL2,8,MI2
        DB 8,RE2,8,DO2,4,DO2,8,DO2,8,RE2,16,MI2,16,DE,16,MI2,16,DE
        DB 16,MI2,16,DE,16,MI2,16,DE,8,RE2,16,DO2,16,DE,16,DO2,16,DE
        DB 16,DO2,16,DE

        DB 16,LA1,16,DE,16,LA1,16,DE,16,LA1,16,DE,16,LA1,16,DE
        DB 8,RE2,8,DO2,8,SI1,8,LA1,16,SOL1,16,DE,16,SOL1,16,DE,8,DO2,8,RE2
        DB 8,MI2,16,RE2,16,DE,8,LA1,8,SI1,2,DO2,4,DO2

        DB 00

;AXEL_B

MELO_2: DB 4,MI2,8,SOL2,16,SOL2,8,MI2,16,MI2,8,LA2,8,MI2,8,RE2
        DB 4,MI2,8,SI2,16,SI2,8,MI2,16,MI2,8,RE3,8,DO3,8,FA2
        DB 8,MI2,8,SI2,8,MI3,16,MI2,8,RE2,16,RE2,8,SI1,8,FA2_,4,MI2

        DB 00
;gmRONDO

MELO_0: DB 4,DE,16,SOL2,16,LA2,16,SI2,16,DO3
        DB 8,RE3,8,DE,16,DO3,16,SI2,16,LA2,16,SOL2
        DB 8,FA2,8,DE,16,SOL2,16,FA2,16,MI2,16,RE2
        DB 16,SOL2,16,DE,16,SOL2,16,DE,16,LA2,16,SOL2,16,FA2,16,SOL2
        DB 8,LA2,8,DE,16,LA2,16,SI2,16,DO3,16,RE3
        DB 8,MI3,8,DE,16,RE3,16,DO3,16,SI2,16,LA2
        DB 16,RE3,16,DE,16,RE3,16,DE,16,DO3,16,SI2,16,LA2,16,SOL2
        DB 16,DO3,16,DE,16,DO3,16,DE,16,SI2,16,LA2,16,SOL2,16,FA2

        DB 00

;DIRHY03A

MELO_1: DB 4,DE,16,DO1,16,RE1_,16,RE1,16,DO1,8,DE,16,DE,16,RE1,16,SOL1
        DB 16,FA1,16,RE1_,16,RE1

        DB 16,RE1_,16,DO1,16,RE1_,16,SOL1,16,DO2,16,RE2_,16,RE2,16,DO2
        DB 16,RE2,16,DO2,16,SI1,16,LA1,16,SOL1,16,FA1,16,RE1_,16,RE1

        DB 16,RE1_,16,DO1,16,RE1_,16,SOL1,16,DO2,16,RE2_,16,RE2,16,DO2
        DB 16,SI1,16,SOL1,16,LA1_,16,RE2,16,SOL2,16,FA2,16,RE2_,16,RE2

        DB 16,RE2_,16,DO2,16,RE2_,16,SOL2,16,DO3,16,RE3_,16,RE3,16,DO3
        DB 16,RE3,16,DO3,16,SI2,16,LA2,16,SOL2,16,FA2,16,RE2_,16,RE2

        DB 8,DO2
        DB 00

;CLASSIC

;MELO_4:        DB 16,LA2,16,SOL2,16,FA2_,16,MI2

        DB 8,MI2,16,RE2,16,DE,2,RE2,16,MI2,16,RE2,16,DO2,16,SI1

        DB 8,FA2_,16,FA2_,16,SOL2,2,RE2,16,MI2,16,RE2,16,DO2,16,SI1

        DB 4,RE2_,4,MI2,16,MI2,16,SOL2,16,FA2_,16,SOL2,16,LA2,16,SOL2,16,FA2_
        DB 16,MI2,4,MI2,2,RE2

        DB 00

;Entten

;MELO_5:        DB 8,RE3,16,RE1,16,RE1_
        DB 16,MI1,8,DO2,16,MI1,8,DO2,16,MI1,16,DO2,4,DO2,16,DE,16,DO2,16,DO3
        DB 16,RE3,16,RE3_

        DB 16,MI3,16,DO3,16,RE3,8,MI3,16,SI2,8,RE3,4,DO3,8,DO3,16,RE1,16,RE1_

        DB 16,MI1,8,DO2,16,MI1,8,DO2,16,MI1,16,DO2,4,DO2,8,DO2,16,LA2,16,SOL2

        DB 16,FA2_,16,LA2,16,DO3,8,MI3,16,RE3,16,DO3,16,LA2,4,RE3,8,RE3


        ;DB 16,RE3,16,MI3,16,DO3,8,LA2,16,SI2,8,SOL2,16,RE2,16,MI2,16,DO2
        ;DB 8,LA1,16,SI1,8,SOL1

        DB 00







        DB ' Boul Gr.62 1998 '
        ; Cracked by SkyDragon



END